
lpacketsizes = { 2147483647, 5000000, 1000000 }
file = ""
outputdir = ""
PATHSEP = gs.pathsep()


function splitfile()
  local fc = gs.splitfilename(file)
  local packet = 0  
  local outfile = nil
  local size = tonumber(gs.comboboxvalue(cbsplit))
  local inp = assert(io.open(file, "rb"))  
  local out = nil
  local block = 2048
  local count = 0
  gs.setlabel(labstatus, "Please wait...")          
  while true do
    local bytes = inp:read(block)
    if not bytes then break end
    count = count + block
    if ( (outfile == nil) or (count >= size) ) then 
      if (outfile ~= nil) then
        out:close() 
      end
      count = 0
      packet = packet + 1
      outfile = outputdir .. fc[2] .. "_packet_" .. packet .. fc[3]   
      out = assert(io.open(outfile, "wb"))     
    end
    out:write(bytes)
  end
  out:close()
  gs.setlabel(labstatus, "Finished.")          
  print("done")
end

function doublefile(size)
  local fc = gs.splitfilename(file)
  local outfile = outputdir .. fc[2] .. "_double" .. fc[3]   
  print(outfile)
  local inp = assert(io.open(file, "rb"))  
  local out = assert(io.open(outfile, "wb"))
  local block = 2048
  local count = 0
  local round = 0
  gs.setlabel(labstatus, "Creating double movie - Please wait...")          
  while true do
    local bytes = inp:read(block)
    if not bytes then 
      round = round + 1
      if (round == 2) then break end
      inp:close()
      inp = assert(io.open(file, "rb"))        
      bytes = inp:read(block)
    end  
    count = count + block    
    out:write(bytes)
  end  
  inp:close()
  out:close()
  gs.setlabel(labstatus, "Creating double movie finished.")          
  print("done")
end

function choosefile()
  local afile = gs.choosefiledialog{caption="Choose file"}  
  if (afile == "") then return end
  file = afile
  gs.setlabel(labfile, file)
  --gs.messagebox{caption="size", msg=gs.filesize(file)}
  if (outputdir == "") then
    local fc = gs.splitfilename(file)
    outputdir =  fc[1] 
  end
end


-- create GUI
local w = 400
local h0 = 18
local h = 24
local h1 = 40
local h11 = 50
local h2 = 120
local pady = 2
local y = 10
local x = 20

win = gs.window{caption="File Splitter", rect={80,30,500,400} }

gs.label{parent=win, rect={x,y,w,h1}, caption="Splits files into packets of same size" }
y = y + h1 + pady
gs.button{parent=win,  rect={x+w*0.2,y,w*0.6,h}, caption="Choose file...", onclick="choosefile()" }
y = y + h1 + pady
gs.label{parent=win, rect={x,y,w,h1}, caption="File: " }
y = y + h0
labfile = gs.label{parent=win, rect={x,y,w,h}, caption="<not yet selected>" }
y = y + h1 + pady
gs.label{parent=win, rect={x,y,w,h1}, caption="Packet size:" }
y = y + h0 
cbsplit = gs.combobox{parent=win,  rect={x,y,w,h} }
y = y + h1 + pady
gs.button{parent=win,  rect={x+w*0.2,y,w*0.6,h}, caption="Split", onclick="splitfile()" }
y = y + h1 + pady
gs.button{parent=win,  rect={x+w*0.2,y,w*0.6,h}, caption="Exit", onclick="gs.exit()" }
y = y + h
labstatus = gs.label{parent=win, rect={x,y,w,h1}, caption="" }
for k,v in pairs(lpacketsizes) do gs.addcombobox(cbsplit, v) end
gs.selectcombobox(cbsplit, 0)




gs.run()


